Index: LMDZ4/branches/V3_test/libf/dyn3dpar/addfi_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/addfi_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/addfi_p.F	(revision 709)
@@ -82,4 +82,5 @@
       ije=ij_end
       
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO k = 1,llm
          DO j = ijb,ije
@@ -87,6 +88,8 @@
          ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 
       if (pole_nord) then
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
         DO  k    = 1, llm
          DO  ij   = 1, iim
@@ -99,7 +102,9 @@
          ENDDO
        ENDDO
+c$OMP END DO NOWAIT
       endif
 
       if (pole_sud) then
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
         DO  k    = 1, llm
          DO  ij   = 1, iim
@@ -112,4 +117,5 @@
          ENDDO
        ENDDO
+c$OMP END DO NOWAIT
       endif
 c
@@ -119,5 +125,6 @@
       if (pole_nord) ijb=ij_begin+iip1
       if (pole_sud)  ije=ij_end-iip1
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO k = 1,llm
          DO j = ijb,ije
@@ -125,7 +132,9 @@
          ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 
       if (pole_nord) ijb=ij_begin
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO k = 1,llm
          DO j = ijb,ije
@@ -133,14 +142,16 @@
          ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 
 c
       if (pole_sud)  ije=ij_end
-
+c$OMP MASTER
       DO j = ijb,ije
          pps(j) = pps(j) + pdpfi(j) * pdt
       ENDDO
- 
+c$OMP END MASTER
  
       DO iq = 1, 2
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
          DO k = 1,llm
             DO j = ijb,ije
@@ -149,8 +160,9 @@
             ENDDO
          ENDDO
-      ENDDO
-
+c$OMP END DO NOWAIT
+      ENDDO
 
       DO iq = 3, nq
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
          DO k = 1,llm
             DO j = ijb,ije
@@ -159,6 +171,8 @@
             ENDDO
          ENDDO
-      ENDDO
-
+c$OMP END DO NOWAIT
+      ENDDO
+
+c$OMP MASTER
       if (pole_nord) then
       
@@ -188,7 +202,9 @@
       
       endif
+c$OMP END MASTER
 
       if (pole_nord) then
         DO iq = 1, nq
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
           DO  k    = 1, llm
             DO  ij   = 1, iim
@@ -201,4 +217,5 @@
             ENDDO
           ENDDO
+c$OMP END DO NOWAIT	  
         ENDDO
       endif
@@ -206,4 +223,5 @@
       if (pole_sud) then
         DO iq = 1, nq
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
           DO  k    = 1, llm
             DO  ij   = 1, iim
@@ -216,4 +234,5 @@
             ENDDO
           ENDDO
+c$OMP END DO NOWAIT	  
         ENDDO
       endif
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/advtrac_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/advtrac_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/advtrac_p.F	(revision 709)
@@ -4,5 +4,5 @@
 c
 c
-#ifdef INCA_CH4
+#ifdef INCA
       SUBROUTINE advtrac_p(pbaru,pbarv ,
      *                   p,  masse,q,iapptrac,teta,
@@ -25,4 +25,5 @@
 c
       USE parallel
+      USE Write_Field_p
       USE Bands
       USE mod_hallo
@@ -56,5 +57,5 @@
       REAL p( ip1jmp1,llmp1 ),teta(ip1jmp1,llm)
       REAL pk(ip1jmp1,llm)
-#ifdef INCA_CH4
+#ifdef INCA
 cym      INTEGER            :: hadv_flg(nq)
          INTEGER            :: hadv_flg(nqmx)
@@ -70,5 +71,5 @@
       REAL pbaruc(ip1jmp1,llm),pbarvc(ip1jm,llm)
       REAL massem(ip1jmp1,llm),zdp(ip1jmp1)
-      REAL pbarug(ip1jmp1,llm),pbarvg(ip1jm,llm),wg(ip1jmp1,llm) 
+      REAL,SAVE::pbarug(ip1jmp1,llm),pbarvg(ip1jm,llm),wg(ip1jmp1,llm) 
       REAL (kind=kind(1.d0)) :: t_initial, t_final, tps_cpu
       real cpuadv(nqmx)
@@ -78,7 +79,7 @@
       INTEGER ij,l,iq,iiq
       REAL zdpmin, zdpmax
-      EXTERNAL  minmax
       SAVE iadvtr, massem, pbaruc, pbarvc
       DATA iadvtr/0/
+c$OMP THREADPRIVATE(iadvtr)
 c----------------------------------------------------------
 c     Rajouts pour PPM
@@ -98,7 +99,7 @@
       integer ijb,ije,ijb_u,ijb_v,ije_u,ije_v,j
       type(Request) :: Request_vanleer
-      REAL p_tmp( ip1jmp1,llmp1 )
-      REAL teta_tmp(ip1jmp1,llm)
-      REAL pk_tmp(ip1jmp1,llm)
+      REAL,SAVE :: p_tmp( ip1jmp1,llmp1 )
+      REAL,SAVE :: teta_tmp(ip1jmp1,llm)
+      REAL,SAVE :: pk_tmp(ip1jmp1,llm)
       
       ijb_u=ij_begin
@@ -113,11 +114,14 @@
 c         CALL initial0(ijp1llm,pbaruc)
 c         CALL initial0(ijmllm,pbarvc)
-          
-          pbaruc(ijb_u:ije_u,:)=0.
-          pbarvc(ijb_v:ije_v,:)=0.
-          
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)        
+	DO l=1,llm   
+          pbaruc(ijb_u:ije_u,l)=0.
+          pbarvc(ijb_v:ije_v,l)=0.
+        ENDDO
+c$OMP END DO NOWAIT  
       ENDIF
 
 c   accumulation des flux de masse horizontaux
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
          DO ij = ijb_u,ije_u
@@ -128,4 +132,5 @@
          ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 
 c   selection de la masse instantannee des mailles avant le transport.
@@ -136,5 +141,10 @@
           ije=ij_end
 
-          massem(ijb:ije,:)=masse(ijb:ije,:)
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+       DO l=1,llm
+          massem(ijb:ije,l)=masse(ijb:ije,l)
+       ENDDO
+c$OMP END DO NOWAIT
+
 ccc         CALL filtreg ( massem ,jjp1, llm,-2, 2, .TRUE., 1 )
 c
@@ -142,29 +152,36 @@
 
       iadvtr   = iadvtr+1
+
+c$OMP MASTER
       iapptrac = iadvtr
-
+c$OMP END MASTER
 
 c   Test pour savoir si on advecte a ce pas de temps
-      
+
       IF ( iadvtr.EQ.iapp_tracvl ) THEN
+c$OMP MASTER
         call suspend_timer(timer_caldyn)
+c$OMP END MASTER
       
       ijb=ij_begin
       ije=ij_end
       
+
+cc   ..  Modif P.Le Van  ( 20/12/97 )  ....
+cc
+
+c   traitement des flux de masse avant advection.
+c     1. calcul de w
+c     2. groupement des mailles pres du pole.
+
+c$OMP BARRIER
+        CALL groupe_p( massem, pbaruc,pbarvc, pbarug,pbarvg,wg )
+c$OMP BARRIER
+
+c$OMP BARRIER
+c$OMP MASTER      
       p_tmp(ijb:ije,1:llmp1)=p(ijb:ije,1:llmp1)
       pk_tmp(ijb:ije,1:llm)=pk(ijb:ije,1:llm)
       teta_tmp(ijb:ije,1:llm)=teta(ijb:ije,1:llm)
-      
-
-cc   ..  Modif P.Le Van  ( 20/12/97 )  ....
-cc
-
-c   traitement des flux de masse avant advection.
-c     1. calcul de w
-c     2. groupement des mailles pres du pole.
-
-        CALL groupe_p( massem, pbaruc,pbarvc, pbarug,pbarvg,wg )
-
       call VTb(VTHallo)
       call Register_SwapFieldHallo(pbarug,pbarug,ip1jmp1,llm,
@@ -195,7 +212,8 @@
       call VTb(VTadvection)
       call start_timer(timer_vanleer)
-
-      
-#ifdef INCA_CH4
+c$OMP END MASTER
+c$OMP BARRIER
+      
+#ifdef INCA
       ! ... Flux de masse diaganostiques traceurs
 c      flxw = wg / FLOAT(iapp_tracvl)
@@ -211,5 +229,5 @@
          if (pole_sud) ije=ij_end-iip1
          
-          
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)          
          DO l=1,llm-1
             DO ij = ijb+1,ije
@@ -241,4 +259,5 @@
 
          ENDDO
+c$OMP END DO NOWAIT
 
 c-------------------------------------------------------------------
@@ -253,6 +272,11 @@
 cym      ----> Revérifier lors de la parallélisation des autres schemas
    
-          call massbar_p(massem,massebx,masseby)          
-
+cym          call massbar_p(massem,massebx,masseby)          
+
+          call vlspltgen_p( q,iadv, 2., massem, wg ,
+     *                    pbarug,pbarvg,dtvr,p_tmp,pk_tmp,teta_tmp )
+
+         
+	  GOTO 1234     
 c-----------------------------------------------------------
 c     Appel des sous programmes d'advection
@@ -309,5 +333,5 @@
 
             call pentes_ini (q(1,1,iq),wg,massem,pbarug,pbarvg,0)
-#ifdef INCA_CH4
+#ifdef INCA
        do iiq = iq+1, iq+3
          q(:,:,iiq)=q(:,:,iiq)*mmt_adj(:,:,1)
@@ -328,5 +352,5 @@
            call  prather(q(1,1,iq),wg,massem,pbarug,pbarvg,
      s                     n,dtbon)
-#ifdef INCA_CH4
+#ifdef INCA
        do iiq = iq+1, iq+9
          q(:,:,iiq)=q(:,:,iiq)*mmt_adj(:,:,1)
@@ -441,4 +465,7 @@
        end DO
 
+1234  CONTINUE
+c$OMP BARRIER
+c$OMP MASTER
       ijb=ij_begin
       ije=ij_end
@@ -450,4 +477,5 @@
        ENDDO
 
+
        CALL qminimum_p( q, 2, finmasse )
 
@@ -455,5 +483,5 @@
 c   on reinitialise a zero les flux de masse cumules
 c---------------------------------------------------
-          iadvtr=0
+c          iadvtr=0
 	call VTe(VTadvection)
         call stop_timer(timer_vanleer)
@@ -465,5 +493,5 @@
         enddo
 
-#ifdef INCA_CH4
+#ifdef INCA
        call Register_SwapFieldHallo(flxw,flxw,ip1jmp1,llm,
      *                             jj_nb_caldyn,0,0,Request_vanleer)
@@ -475,5 +503,7 @@
 	call VTe(VThallo)
 	call resume_timer(timer_caldyn)
-	
+c$OMP END MASTER
+c$OMP BARRIER	
+          iadvtr=0
        ENDIF ! if iadvtr.EQ.iapp_tracvl
 
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/advx.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/advx.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/advx.F	(revision 709)
@@ -106,5 +106,5 @@
          DO j = 1,jjp1
             DO i = 1,iim
-               sqi = sqi + S0(i,j,l,9)
+               sqi = sqi + S0(i,j,l,ntra)
             ENDDO
          ENDDO
@@ -483,5 +483,5 @@
         DO j = 1, jjp1
           DO i = 1, iim
-             sqf = sqf + S0(i,j,l,9)
+             sqf = sqf + S0(i,j,l,ntra)
           END DO  
         END DO
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/advz.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/advz.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/advz.F	(revision 709)
@@ -105,5 +105,5 @@
          DO j = 1,jjp1
             DO i = 1,iim
-               sqi = sqi + S0(i,j,l,9)
+               sqi = sqi + S0(i,j,l,ntra)
             ENDDO
          ENDDO
@@ -307,5 +307,5 @@
          DO j = 1,jjp1
             DO i = 1,iim
-               sqf = sqf + S0(i,j,l,9)
+               sqf = sqf + S0(i,j,l,ntra)
             ENDDO
          ENDDO
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/bernoui_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/bernoui_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/bernoui_p.F	(revision 709)
@@ -37,5 +37,4 @@
 c
       INTEGER   ij,l,ijb,ije,jjb,jje
-      EXTERNAL  filtreg_p
 c
 c-----------------------------------------------------------------------
@@ -50,5 +49,6 @@
       jje=jj_end+1
       if (pole_sud) jje=jj_end
-                
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)                
       DO l=1,llm
     
@@ -58,4 +58,5 @@
        
        ENDDO
+c$OMP END DO NOWAIT
 c
 c-----------------------------------------------------------------------
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/bilan_dyn_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/bilan_dyn_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/bilan_dyn_p.F	(revision 709)
@@ -168,4 +168,5 @@
 c   Initialisation
 c=====================================================================
+      ndex3d=0
       if (adjust) return
       
@@ -342,5 +343,5 @@
       Q(:,jjb:jje,:,iang)=ang(:,jjb:jje,:)
       Q(:,jjb:jje,:,iu)=unat(:,jjb:jje,:)
-      Q(:,jjb:jje,:,iovap)=q(:,jjb:jje,:,1)
+      Q(:,jjb:jje,:,iovap)=trac(:,jjb:jje,:,1)
       Q(:,jjb:jje,:,iun)=1.
 
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/caladvtrac_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/caladvtrac_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/caladvtrac_p.F	(revision 709)
@@ -4,5 +4,5 @@
 c
 c
-#ifdef INCA_CH4
+#ifdef INCA
             SUBROUTINE caladvtrac_p(q,pbaru,pbarv ,
      *                   p ,masse, dq ,  teta,
@@ -58,5 +58,4 @@
 c   ------
 
-      EXTERNAL  advtrac,minmaxq, qminimum
       INTEGER ij,l, iq, iapptrac
       REAL finmasse(ip1jmp1,llm), dtvrtrac
@@ -77,4 +76,5 @@
 
 c   advection
+c      print *,'appel a advtrac'
 
 #ifdef INCA_CH4
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/caldyn_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/caldyn_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/caldyn_p.F	(revision 709)
@@ -46,8 +46,9 @@
       REAL ps(ip1jmp1),phis(ip1jmp1)
       REAL pk(iip1,jjp1,llm),pkf(ip1jmp1,llm)
-      REAL vcont(ip1jm,llm),ucont(ip1jmp1,llm)
+      REAL,SAVE :: vcont(ip1jm,llm),ucont(ip1jmp1,llm)
       REAL phi(ip1jmp1,llm),masse(ip1jmp1,llm)
       REAL dv(ip1jm,llm),du(ip1jmp1,llm)
       REAL dteta(ip1jmp1,llm),dp(ip1jmp1)
+      REAL w(ip1jmp1,llm)
       REAL pbaru(ip1jmp1,llm),pbarv(ip1jm,llm)
       REAL time
@@ -56,12 +57,13 @@
 c   ------
 
-      REAL ang(ip1jmp1,llm),p(ip1jmp1,llmp1)
-      REAL massebx(ip1jmp1,llm),masseby(ip1jm,llm),psexbarxy(ip1jm)
-      REAL vorpot(ip1jm,llm)
-      REAL w(ip1jmp1,llm),ecin(ip1jmp1,llm),convm(ip1jmp1,llm)
-      REAL bern(ip1jmp1,llm)
-      REAL massebxy(ip1jm,llm)
-    
-
+      REAL,SAVE :: ang(ip1jmp1,llm)
+      REAL,SAVE :: p(ip1jmp1,llmp1)
+      REAL,SAVE :: massebx(ip1jmp1,llm),masseby(ip1jm,llm)
+      REAL,SAVE :: psexbarxy(ip1jm)
+      REAL,SAVE :: vorpot(ip1jm,llm)
+      REAL,SAVE :: ecin(ip1jmp1,llm)
+      REAL,SAVE :: bern(ip1jmp1,llm)
+      REAL,SAVE :: massebxy(ip1jm,llm)
+      REAL,SAVE :: convm(ip1jmp1,llm)
       INTEGER   ij,l,ijb,ije,ierr
 
@@ -72,4 +74,5 @@
       CALL pression_p ( ip1jmp1, ap      , bp   ,  ps  , p            )
 cym      CALL psextbar (   ps   , psexbarxy                          )
+c$OMP BARRIER
       CALL massdair_p (    p   , masse                                )
       CALL massbar_p  (   masse, massebx , masseby                    )
@@ -77,7 +80,11 @@
       CALL flumass_p  ( massebx, masseby , vcont, ucont ,pbaru, pbarv )
       CALL dteta1_p   (   teta , pbaru   , pbarv, dteta               )
-      CALL convmas_p  (   pbaru, pbarv   , convm                      )
-
+      CALL convmas1_p  (   pbaru, pbarv   , convm                      )
+c$OMP BARRIER      
+      CALL convmas2_p  (   convm                      )
+c$OMP BARRIER
 #ifdef DEBUG_IO
+c$OMP BARRIER
+c$OMP MASTER
       call WriteField_p('ucont',reshape(ucont,(/iip1,jmp1,llm/)))
       call WriteField_p('vcont',reshape(vcont,(/iip1,jjm,llm/)))
@@ -91,6 +98,10 @@
       call WriteField_p('dteta',reshape(dteta,(/iip1,jmp1,llm/)))
       call WriteField_p('convm',reshape(convm,(/iip1,jmp1,llm/)))
+c$OMP END MASTER
+c$OMP BARRIER
 #endif      
 
+c$OMP BARRIER
+c$OMP MASTER
       ijb=ij_begin
       ije=ij_end
@@ -99,5 +110,7 @@
          dp( ij ) = convm( ij,1 ) / airesurg( ij )
       ENDDO
-
+c$OMP END MASTER
+c$OMP BARRIER
+c$OMP FLUSH
       CALL vitvert_p ( convm  , w                                  )
       CALL tourpot_p ( vcov   , ucov  , massebxy  , vorpot         )
@@ -105,8 +118,12 @@
 
 #ifdef DEBUG_IO      
+c$OMP BARRIER
+c$OMP MASTER
       call WriteField_p('w',reshape(w,(/iip1,jmp1,llm/)))
       call WriteField_p('vorpot',reshape(vorpot,(/iip1,jjm,llm/)))
       call WriteField_p('du',reshape(du,(/iip1,jmp1,llm/)))
       call WriteField_p('dv',reshape(dv,(/iip1,jjm,llm/)))
+c$OMP END MASTER
+c$OMP BARRIER
 #endif      
       CALL enercin_p ( vcov   , ucov  , vcont     , ucont  , ecin  )
@@ -115,8 +132,13 @@
 
 #ifdef DEBUG_IO
+c$OMP BARRIER
+c$OMP MASTER
       call WriteField_p('ecin',reshape(ecin,(/iip1,jmp1,llm/)))
       call WriteField_p('bern',reshape(bern,(/iip1,jmp1,llm/)))
       call WriteField_p('du',reshape(du,(/iip1,jmp1,llm/)))
       call WriteField_p('dv',reshape(dv,(/iip1,jjm,llm/)))
+      call WriteField_p('pkf',reshape(pkf,(/iip1,jmp1,llm/)))
+c$OMP END MASTER
+c$OMP BARRIER
 #endif
       
@@ -126,5 +148,6 @@
       if (pole_nord) ijb=ij_begin
       if (pole_sud) ije=ij_end
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
       DO l=1,llm
          DO ij=ijb,ije
@@ -132,7 +155,7 @@
         ENDDO
       ENDDO
+c$OMP END DO
 
-
-      CALL advect_p( ang, vcov, teta, w, massebx, masseby,du,dv,dteta) 
+      CALL advect_new_p(ang,vcov,teta,w,massebx,masseby,du,dv,dteta) 
 
 C  WARNING probleme de peridocite de dv sur les PC/linux. Pb d'arrondi 
@@ -142,4 +165,5 @@
       if (pole_sud) ije=ij_end-iip1
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
       DO l = 1, llm
          DO ij = ijb, ije, iip1
@@ -152,4 +176,5 @@
          enddo
       enddo
+c$OMP END DO NOWAIT      
 c-----------------------------------------------------------------------
 c   Sorties eventuelles des variables de controle:
